]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test: Remove some dead code in test-lib.sh
[notmuch] / test / test-lib.sh
1 #!/bin/bash
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
33
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
36
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
45
46 # Protect ourselves from common misconfiguration to export
47 # CDPATH into the environment
48 unset CDPATH
49
50 unset GREP_OPTIONS
51
52 # Convenience
53 #
54 # A regexp to match 5 and 40 hexdigits
55 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
56 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
57
58 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
59 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
60
61 # Each test should start with something like this, after copyright notices:
62 #
63 # test_description='Description of this test...
64 # This test checks if command xyzzy does the right thing...
65 # '
66 # . ./test-lib.sh
67 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
68                 TERM=$ORIGINAL_TERM &&
69                 export TERM &&
70                 [ -t 1 ] &&
71                 tput bold >/dev/null 2>&1 &&
72                 tput setaf 1 >/dev/null 2>&1 &&
73                 tput sgr0 >/dev/null 2>&1
74         ) &&
75         color=t
76
77 while test "$#" -ne 0
78 do
79         case "$1" in
80         -d|--d|--de|--deb|--debu|--debug)
81                 debug=t; shift ;;
82         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
83                 immediate=t; shift ;;
84         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
85                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
86         -h|--h|--he|--hel|--help)
87                 help=t; shift ;;
88         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
89                 verbose=t; shift ;;
90         -q|--q|--qu|--qui|--quie|--quiet)
91                 quiet=t; shift ;;
92         --with-dashes)
93                 with_dashes=t; shift ;;
94         --no-color)
95                 color=; shift ;;
96         --no-python)
97                 # noop now...
98                 shift ;;
99         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
100                 valgrind=t; verbose=t; shift ;;
101         --tee)
102                 shift ;; # was handled already
103         --root=*)
104                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
105                 shift ;;
106         *)
107                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
108         esac
109 done
110
111 if test -n "$color"; then
112         say_color () {
113                 (
114                 TERM=$ORIGINAL_TERM
115                 export TERM
116                 case "$1" in
117                         error) tput bold; tput setaf 1;; # bold red
118                         skip)  tput bold; tput setaf 2;; # bold green
119                         pass)  tput setaf 2;;            # green
120                         info)  tput setaf 3;;            # brown
121                         *) test -n "$quiet" && return;;
122                 esac
123                 shift
124                 printf " "
125                 printf "$@"
126                 tput sgr0
127                 )
128         }
129 else
130         say_color() {
131                 test -z "$1" && test -n "$quiet" && return
132                 shift
133                 printf " "
134                 printf "$@"
135         }
136 fi
137
138 error () {
139         say_color error "error: $*"
140         GIT_EXIT_OK=t
141         exit 1
142 }
143
144 say () {
145         say_color info "$*"
146 }
147
148 test "${test_description}" != "" ||
149 error "Test script did not set test_description."
150
151 if test "$help" = "t"
152 then
153         echo "Tests ${test_description}"
154         exit 0
155 fi
156
157 echo $(basename "$0"): "Testing ${test_description}"
158
159 exec 5>&1
160 if test "$verbose" = "t"
161 then
162         exec 4>&2 3>&1
163 else
164         exec 4>/dev/null 3>/dev/null
165 fi
166
167 test_failure=0
168 test_count=0
169 test_fixed=0
170 test_broken=0
171 test_success=0
172
173 die () {
174         code=$?
175         if test -n "$GIT_EXIT_OK"
176         then
177                 exit $code
178         else
179                 echo >&5 "FATAL: Unexpected exit with code $code"
180                 exit 1
181         fi
182 }
183
184 GIT_EXIT_OK=
185 trap 'die' EXIT
186
187 test_decode_color () {
188         sed     -e 's/.\[1m/<WHITE>/g' \
189                 -e 's/.\[31m/<RED>/g' \
190                 -e 's/.\[32m/<GREEN>/g' \
191                 -e 's/.\[33m/<YELLOW>/g' \
192                 -e 's/.\[34m/<BLUE>/g' \
193                 -e 's/.\[35m/<MAGENTA>/g' \
194                 -e 's/.\[36m/<CYAN>/g' \
195                 -e 's/.\[m/<RESET>/g'
196 }
197
198 q_to_nul () {
199         perl -pe 'y/Q/\000/'
200 }
201
202 q_to_cr () {
203         tr Q '\015'
204 }
205
206 append_cr () {
207         sed -e 's/$/Q/' | tr Q '\015'
208 }
209
210 remove_cr () {
211         tr '\015' Q | sed -e 's/Q$//'
212 }
213
214 # Notmuch helper functions
215 increment_mtime_amount=0
216 increment_mtime ()
217 {
218     dir="$1"
219
220     increment_mtime_amount=$((increment_mtime_amount + 1))
221     touch -d "+${increment_mtime_amount} seconds" "$dir"
222 }
223
224 # Generate a new message in the mail directory, with a unique message
225 # ID and subject. The message is not added to the index.
226 #
227 # After this function returns, the filename of the generated message
228 # is available as $gen_msg_filename and the message ID is available as
229 # $gen_msg_id .
230 #
231 # This function supports named parameters with the bash syntax for
232 # assigning a value to an associative array ([name]=value). The
233 # supported parameters are:
234 #
235 #  [dir]=directory/of/choice
236 #
237 #       Generate the message in directory 'directory/of/choice' within
238 #       the mail store. The directory will be created if necessary.
239 #
240 #  [body]=text
241 #
242 #       Text to use as the body of the email message
243 #
244 #  '[from]="Some User <user@example.com>"'
245 #  '[to]="Some User <user@example.com>"'
246 #  '[subject]="Subject of email message"'
247 #  '[date]="RFC 822 Date"'
248 #
249 #       Values for email headers. If not provided, default values will
250 #       be generated instead.
251 #
252 #  '[cc]="Some User <user@example.com>"'
253 #  [reply-to]=some-address
254 #  [in-reply-to]=<message-id>
255 #  [references]=<message-id>
256 #  [content-type]=content-type-specification
257 #  '[header]=full header line, including keyword'
258 #
259 #       Additional values for email headers. If these are not provided
260 #       then the relevant headers will simply not appear in the
261 #       message.
262 #
263 #  '[id]=message-id'
264 #
265 #       Controls the message-id of the created message.
266 gen_msg_cnt=0
267 gen_msg_filename=""
268 gen_msg_id=""
269 generate_message ()
270 {
271     # This is our (bash-specific) magic for doing named parameters
272     local -A template="($@)"
273     local additional_headers
274
275     gen_msg_cnt=$((gen_msg_cnt + 1))
276     gen_msg_name=msg-$(printf "%03d" $gen_msg_cnt)
277
278     if [ -z "${template[id]}" ]; then
279         gen_msg_id="${gen_msg_name}@notmuch-test-suite"
280     else
281         gen_msg_id="${template[id]}"
282     fi
283
284     if [ -z "${template[dir]}" ]; then
285         gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
286     else
287         gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
288         mkdir -p "$(dirname "$gen_msg_filename")"
289     fi
290
291     if [ -z "${template[body]}" ]; then
292         template[body]="This is just a test message (#${gen_msg_cnt})"
293     fi
294
295     if [ -z "${template[from]}" ]; then
296         template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
297     fi
298
299     if [ -z "${template[to]}" ]; then
300         template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
301     fi
302
303     if [ -z "${template[subject]}" ]; then
304         template[subject]="Test message #${gen_msg_cnt}"
305     fi
306
307     if [ -z "${template[date]}" ]; then
308         template[date]="Tue, 05 Jan 2001 15:43:57 -0000"
309     fi
310
311     additional_headers=""
312     if [ ! -z "${template[header]}" ]; then
313         additional_headers="${template[header]}
314 ${additional_headers}"
315     fi
316
317     if [ ! -z "${template[reply-to]}" ]; then
318         additional_headers="Reply-To: ${template[reply-to]}
319 ${additional_headers}"
320     fi
321
322     if [ ! -z "${template[in-reply-to]}" ]; then
323         additional_headers="In-Reply-To: ${template[in-reply-to]}
324 ${additional_headers}"
325     fi
326
327     if [ ! -z "${template[cc]}" ]; then
328         additional_headers="Cc: ${template[cc]}
329 ${additional_headers}"
330     fi
331
332     if [ ! -z "${template[references]}" ]; then
333         additional_headers="References: ${template[references]}
334 ${additional_headers}"
335     fi
336
337     if [ ! -z "${template[content-type]}" ]; then
338         additional_headers="Content-Type: ${template[content-type]}
339 ${additional_headers}"
340     fi
341
342
343 cat <<EOF >"$gen_msg_filename"
344 From: ${template[from]}
345 To: ${template[to]}
346 Message-Id: <${gen_msg_id}>
347 Subject: ${template[subject]}
348 Date: ${template[date]}
349 ${additional_headers}
350 ${template[body]}
351 EOF
352
353     # Ensure that the mtime of the containing directory is updated
354     increment_mtime "$(dirname "${gen_msg_filename}")"
355 }
356
357 # Generate a new message and add it to the index.
358 #
359 # All of the arguments and return values supported by generate_message
360 # are also supported here, so see that function for details.
361 add_message ()
362 {
363     generate_message "$@" &&
364     notmuch new > /dev/null
365 }
366
367 test_begin_subtest ()
368 {
369     test_subtest_name="$1"
370 }
371
372 # Pass test if two arguments match
373 #
374 # Note: Unlike all other test_expect_* functions, this function does
375 # not accept a test name. Instead, the caller should call
376 # test_begin_subtest before calling this function in order to set the
377 # name.
378 test_expect_equal ()
379 {
380         test "$#" = 3 && { prereq=$1; shift; } || prereq=
381         test "$#" = 2 ||
382         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
383
384         output="$1"
385         expected="$2"
386         if ! test_skip "$@"
387         then
388                 if [ "$output" = "$expected" ]; then
389                         test_ok_ "$test_subtest_name"
390                 else
391                         testname=$this_test.$test_count
392                         echo "$expected" > $testname.expected
393                         echo "$output" > $testname.output
394                         test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
395                 fi
396     fi
397 }
398
399 NOTMUCH=notmuch
400
401 NOTMUCH_NEW ()
402 {
403     notmuch new | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
404 }
405
406 notmuch_search_sanitize ()
407 {
408     sed -r -e 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
409 }
410
411 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
412 notmuch_show_sanitize ()
413 {
414     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
415 }
416
417 # End of notmuch helper functions
418
419 # Use test_set_prereq to tell that a particular prerequisite is available.
420 # The prerequisite can later be checked for in two ways:
421 #
422 # - Explicitly using test_have_prereq.
423 #
424 # - Implicitly by specifying the prerequisite tag in the calls to
425 #   test_expect_{success,failure,code}.
426 #
427 # The single parameter is the prerequisite tag (a simple word, in all
428 # capital letters by convention).
429
430 test_set_prereq () {
431         satisfied="$satisfied$1 "
432 }
433 satisfied=" "
434
435 test_have_prereq () {
436         case $satisfied in
437         *" $1 "*)
438                 : yes, have it ;;
439         *)
440                 ! : nope ;;
441         esac
442 }
443
444 # You are not expected to call test_ok_ and test_failure_ directly, use
445 # the text_expect_* functions instead.
446
447 test_ok_ () {
448         test_success=$(($test_success + 1))
449         say_color pass "%-6s" "PASS"
450         echo " $@"
451 }
452
453 test_failure_ () {
454         test_failure=$(($test_failure + 1))
455         say_color error "%-6s" "FAIL"
456         echo " $1"
457         shift
458         echo "$@" | sed -e 's/^/        /'
459         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
460 }
461
462 test_known_broken_ok_ () {
463         test_fixed=$(($test_fixed+1))
464         say_color pass "%-6s" "FIXED"
465         echo " $@"
466 }
467
468 test_known_broken_failure_ () {
469         test_broken=$(($test_broken+1))
470         say_color pass "%-6s" "BROKEN"
471         echo " $@"
472 }
473
474 test_debug () {
475         test "$debug" = "" || eval "$1"
476 }
477
478 test_run_ () {
479         test_cleanup=:
480         eval >&3 2>&4 "$1"
481         eval_ret=$?
482         eval >&3 2>&4 "$test_cleanup"
483         return 0
484 }
485
486 test_skip () {
487         test_count=$(($test_count+1))
488         to_skip=
489         for skp in $NOTMUCH_SKIP_TESTS
490         do
491                 case $this_test.$test_count in
492                 $skp)
493                         to_skip=t
494                 esac
495         done
496         if test -z "$to_skip" && test -n "$prereq" &&
497            ! test_have_prereq "$prereq"
498         then
499                 to_skip=t
500         fi
501         case "$to_skip" in
502         t)
503                 say_color skip >&3 "skipping test: $@"
504                 say_color skip "%-6s" "SKIP"
505                 echo " $1"
506                 : true
507                 ;;
508         *)
509                 false
510                 ;;
511         esac
512 }
513
514 test_expect_failure () {
515         test "$#" = 3 && { prereq=$1; shift; } || prereq=
516         test "$#" = 2 ||
517         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
518         if ! test_skip "$@"
519         then
520                 test_run_ "$2"
521                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
522                 then
523                         test_known_broken_ok_ "$1"
524                 else
525                         test_known_broken_failure_ "$1"
526                 fi
527         fi
528 }
529
530 test_expect_success () {
531         test "$#" = 3 && { prereq=$1; shift; } || prereq=
532         test "$#" = 2 ||
533         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
534         if ! test_skip "$@"
535         then
536                 test_run_ "$2"
537                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
538                 then
539                         test_ok_ "$1"
540                 else
541                         test_failure_ "$@"
542                 fi
543         fi
544 }
545
546 test_expect_code () {
547         test "$#" = 4 && { prereq=$1; shift; } || prereq=
548         test "$#" = 3 ||
549         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
550         if ! test_skip "$@"
551         then
552                 test_run_ "$3"
553                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
554                 then
555                         test_ok_ "$2"
556                 else
557                         test_failure_ "$@"
558                 fi
559         fi
560 }
561
562 # test_external runs external test scripts that provide continuous
563 # test output about their progress, and succeeds/fails on
564 # zero/non-zero exit code.  It outputs the test output on stdout even
565 # in non-verbose mode, and announces the external script with "* run
566 # <n>: ..." before running it.  When providing relative paths, keep in
567 # mind that all scripts run in "trash directory".
568 # Usage: test_external description command arguments...
569 # Example: test_external 'Perl API' perl ../path/to/test.pl
570 test_external () {
571         test "$#" = 4 && { prereq=$1; shift; } || prereq=
572         test "$#" = 3 ||
573         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
574         descr="$1"
575         shift
576         if ! test_skip "$descr" "$@"
577         then
578                 # Announce the script to reduce confusion about the
579                 # test output that follows.
580                 say_color "" " run $test_count: $descr ($*)"
581                 # Run command; redirect its stderr to &4 as in
582                 # test_run_, but keep its stdout on our stdout even in
583                 # non-verbose mode.
584                 "$@" 2>&4
585                 if [ "$?" = 0 ]
586                 then
587                         test_ok_ "$descr"
588                 else
589                         test_failure_ "$descr" "$@"
590                 fi
591         fi
592 }
593
594 # Like test_external, but in addition tests that the command generated
595 # no output on stderr.
596 test_external_without_stderr () {
597         # The temporary file has no (and must have no) security
598         # implications.
599         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
600         stderr="$tmp/git-external-stderr.$$.tmp"
601         test_external "$@" 4> "$stderr"
602         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
603         descr="no stderr: $1"
604         shift
605         if [ ! -s "$stderr" ]; then
606                 rm "$stderr"
607                 test_ok_ "$descr"
608         else
609                 if [ "$verbose" = t ]; then
610                         output=`echo; echo Stderr is:; cat "$stderr"`
611                 else
612                         output=
613                 fi
614                 # rm first in case test_failure exits.
615                 rm "$stderr"
616                 test_failure_ "$descr" "$@" "$output"
617         fi
618 }
619
620 # This is not among top-level (test_expect_success | test_expect_failure)
621 # but is a prefix that can be used in the test script, like:
622 #
623 #       test_expect_success 'complain and die' '
624 #           do something &&
625 #           do something else &&
626 #           test_must_fail git checkout ../outerspace
627 #       '
628 #
629 # Writing this as "! git checkout ../outerspace" is wrong, because
630 # the failure could be due to a segv.  We want a controlled failure.
631
632 test_must_fail () {
633         "$@"
634         test $? -gt 0 -a $? -le 129 -o $? -gt 192
635 }
636
637 # test_cmp is a helper function to compare actual and expected output.
638 # You can use it like:
639 #
640 #       test_expect_success 'foo works' '
641 #               echo expected >expected &&
642 #               foo >actual &&
643 #               test_cmp expected actual
644 #       '
645 #
646 # This could be written as either "cmp" or "diff -u", but:
647 # - cmp's output is not nearly as easy to read as diff -u
648 # - not all diff versions understand "-u"
649
650 test_cmp() {
651         $GIT_TEST_CMP "$@"
652 }
653
654 # This function can be used to schedule some commands to be run
655 # unconditionally at the end of the test to restore sanity:
656 #
657 #       test_expect_success 'test core.capslock' '
658 #               git config core.capslock true &&
659 #               test_when_finished "git config --unset core.capslock" &&
660 #               hello world
661 #       '
662 #
663 # That would be roughly equivalent to
664 #
665 #       test_expect_success 'test core.capslock' '
666 #               git config core.capslock true &&
667 #               hello world
668 #               git config --unset core.capslock
669 #       '
670 #
671 # except that the greeting and config --unset must both succeed for
672 # the test to pass.
673
674 test_when_finished () {
675         test_cleanup="{ $*
676                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
677 }
678
679 test_done () {
680         GIT_EXIT_OK=t
681         test_results_dir="$TEST_DIRECTORY/test-results"
682         mkdir -p "$test_results_dir"
683         test_results_path="$test_results_dir/${0%.sh}-$$"
684
685         echo "total $test_count" >> $test_results_path
686         echo "success $test_success" >> $test_results_path
687         echo "fixed $test_fixed" >> $test_results_path
688         echo "broken $test_broken" >> $test_results_path
689         echo "failed $test_failure" >> $test_results_path
690         echo "" >> $test_results_path
691
692         echo
693
694         if [ "$test_failure" = "0" ]; then
695             rm -rf "$remove_tmp"
696             exit 0
697         else
698             exit 1
699         fi
700 }
701
702 find_notmuch_path ()
703 {
704     dir="$1"
705
706     while [ -n "$dir" ]; do
707         bin="$dir/notmuch"
708         if [ -x "$bin" ]; then
709             echo "$dir"
710             return
711         fi
712         dir="$(dirname "$dir")"
713         if [ "$dir" = "/" ]; then
714             break
715         fi
716     done
717 }
718
719 # Test the binaries we have just built.  The tests are kept in
720 # test/ subdirectory and are run in 'trash directory' subdirectory.
721 TEST_DIRECTORY=$(pwd)
722 if test -n "$valgrind"
723 then
724         make_symlink () {
725                 test -h "$2" &&
726                 test "$1" = "$(readlink "$2")" || {
727                         # be super paranoid
728                         if mkdir "$2".lock
729                         then
730                                 rm -f "$2" &&
731                                 ln -s "$1" "$2" &&
732                                 rm -r "$2".lock
733                         else
734                                 while test -d "$2".lock
735                                 do
736                                         say "Waiting for lock on $2."
737                                         sleep 1
738                                 done
739                         fi
740                 }
741         }
742
743         make_valgrind_symlink () {
744                 # handle only executables
745                 test -x "$1" || return
746
747                 base=$(basename "$1")
748                 symlink_target=$TEST_DIRECTORY/../$base
749                 # do not override scripts
750                 if test -x "$symlink_target" &&
751                     test ! -d "$symlink_target" &&
752                     test "#!" != "$(head -c 2 < "$symlink_target")"
753                 then
754                         symlink_target=../valgrind.sh
755                 fi
756                 case "$base" in
757                 *.sh|*.perl)
758                         symlink_target=../unprocessed-script
759                 esac
760                 # create the link, or replace it if it is out of date
761                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
762         }
763
764         # override notmuch executable in TEST_DIRECTORY/..
765         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
766         mkdir -p "$GIT_VALGRIND"/bin
767         make_valgrind_symlink $TEST_DIRECTORY/../notmuch
768         OLDIFS=$IFS
769         IFS=:
770         for path in $PATH
771         do
772                 ls "$path"/notmuch 2> /dev/null |
773                 while read file
774                 do
775                         make_valgrind_symlink "$file"
776                 done
777         done
778         IFS=$OLDIFS
779         PATH=$GIT_VALGRIND/bin:$PATH
780         GIT_EXEC_PATH=$GIT_VALGRIND/bin
781         export GIT_VALGRIND
782 else # normal case
783         notmuch_path=`find_notmuch_path "$TEST_DIRECTORY"`
784         test -n "$notmuch_path" && PATH="$notmuch_path:$PATH"
785 fi
786 export PATH
787
788 # Test repository
789 test="tmp.$(basename "$0" .sh)"
790 test -n "$root" && test="$root/$test"
791 case "$test" in
792 /*) TMP_DIRECTORY="$test" ;;
793  *) TMP_DIRECTORY="$TEST_DIRECTORY/$test" ;;
794 esac
795 test ! -z "$debug" || remove_tmp=$TMP_DIRECTORY
796 rm -fr "$test" || {
797         GIT_EXIT_OK=t
798         echo >&5 "FATAL: Cannot prepare test area"
799         exit 1
800 }
801
802 MAIL_DIR="${TMP_DIRECTORY}/mail"
803 export NOTMUCH_CONFIG="${TMP_DIRECTORY}/notmuch-config"
804
805 mkdir -p "${test}"
806 mkdir "$MAIL_DIR"
807
808 cat <<EOF >"${NOTMUCH_CONFIG}"
809 [database]
810 path=${MAIL_DIR}
811
812 [user]
813 name=Notmuch Test Suite
814 primary_email=test_suite@notmuchmail.org
815 other_email=test_suite_other@notmuchmail.org;test_suite@otherdomain.org
816 EOF
817
818
819 # Use -P to resolve symlinks in our working directory so that the cwd
820 # in subprocesses like git equals our $PWD (for pathname comparisons).
821 cd -P "$test" || error "Cannot setup test environment"
822
823 this_test=${0##*/}
824 this_test=${this_test%%-*}
825 for skp in $NOTMUCH_SKIP_TESTS
826 do
827         to_skip=
828         for skp in $NOTMUCH_SKIP_TESTS
829         do
830                 case "$this_test" in
831                 $skp)
832                         to_skip=t
833                 esac
834         done
835         case "$to_skip" in
836         t)
837                 say_color skip >&3 "skipping test $this_test altogether"
838                 say_color skip "skip all tests in $this_test"
839                 test_done
840         esac
841 done
842
843 # Provide an implementation of the 'yes' utility
844 yes () {
845         if test $# = 0
846         then
847                 y=y
848         else
849                 y="$*"
850         fi
851
852         while echo "$y"
853         do
854                 :
855         done
856 }
857
858 # Fix some commands on Windows
859 case $(uname -s) in
860 *MINGW*)
861         # Windows has its own (incompatible) sort and find
862         sort () {
863                 /usr/bin/sort "$@"
864         }
865         find () {
866                 /usr/bin/find "$@"
867         }
868         sum () {
869                 md5sum "$@"
870         }
871         # git sees Windows-style pwd
872         pwd () {
873                 builtin pwd -W
874         }
875         # no POSIX permissions
876         # backslashes in pathspec are converted to '/'
877         # exec does not inherit the PID
878         ;;
879 *)
880         test_set_prereq POSIXPERM
881         test_set_prereq BSLASHPSPEC
882         test_set_prereq EXECKEEPSPID
883         ;;
884 esac
885
886 test -z "$NO_PERL" && test_set_prereq PERL
887 test -z "$NO_PYTHON" && test_set_prereq PYTHON
888
889 # test whether the filesystem supports symbolic links
890 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
891 rm -f y